Adds the Bullet gem to detect query problems such as N+1 and improve performance

2025-04-09 16:31 - Katsuya HIDAKA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version: 6.1.0   

Description

This patch adds and enables the Bullet gem in the development environment. Bullet helps Redmine developers detect query

problems such as N+1, making it easier to improve application performance during development.

For example, the following Rails log is shown when viewing an issue in development:

 ...

  ↳ lib/redmine/preparation.rb:383:in `block (2 levels) in prepare'

  Rendered layout layouts/base.html.erb (Duration: 1414.4ms | GC: 251.1ms)

Completed 200 OK in 2320ms (Views: 1377.8ms | ActiveRecord: 81.2ms (102 queries, 16 cached) | GC: 

307.1ms)

user: developer

GET /issues/1

USE eager loading detected

  Journal => [:updated_by]

  Add to your query: .includes([:updated_by])

Call stack

  /redmine/app/models/issue.rb:919:in `visible_journals_with_index'

  /redmine/app/controllers/issues_controller.rb:97:in `show'

  /redmine/lib/redmine/sudo_mode.rb:78:in `sudo_mode'

user: developer

GET /issues/1

AVOID eager loading detected

  User => [:email_address]

  Remove from your query: .includes([:email_address])

Call stack

  /redmine/app/models/issue.rb:919:in `visible_journals_with_index'

  /redmine/app/controllers/issues_controller.rb:97:in `show'

  /redmine/lib/redmine/sudo_mode.rb:78:in `sudo_mode'

Associated revisions

Revision 23621 - 2025-04-10 13:05 - Go MAEDA

Adds the Bullet gem to detect query problems such as N+1 and improve performance (#42555).

Patch by Katsuya HIDAKA (user:hidakatsuya).

History

#1 - 2025-04-10 09:14 - Go MAEDA

- Category set to Performance

- Target version set to 6.1.0

Setting the target version to 6.1.0.

#2 - 2025-04-10 13:11 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

2025-04-19 1/2

https://github.com/flyerhzm/bullet


Committed the patch in r23621 with slight changes:

Removed the version specification for the bullet gem. Since it isn't used in production mode, using the latest version should be fine.

Added Bullet.skip_user_in_notification = true to exclude the OS user from notifications.

Thank you for your contribution.
